package com.app.input.breeze.board.listutils;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.app.input.breeze.board.R;
import com.app.input.breeze.board.bean.KeyboardTheme;
import com.app.input.breeze.board.utils.AppUtils;
import com.app.input.breeze.board.callback.RemoveFavoriteCallback;
import com.app.input.breeze.board.uiactivity.ThemeDetailActivity;

import java.util.ArrayList;
import java.util.List;

public class FavoriteThemeAdapter extends RecyclerView.Adapter<FavoriteThemeAdapter.ForYouViewHolder> {

    private Context mContext;
    private List<KeyboardTheme> mList = new ArrayList<>();

    private RemoveFavoriteCallback mCallBack;

    public FavoriteThemeAdapter(Context context) {
        mContext = context;
    }

    public void setForYouList(List<KeyboardTheme> list) {
        this.mList = list;
        notifyDataSetChanged();
    }


    public void setRemoveLike(RemoveFavoriteCallback callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.favorite_theme_adapter_item, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        KeyboardTheme KeyboardTheme = mList.get(position);
        String thumbGif = KeyboardTheme.getThumbGif();
        String thumb = KeyboardTheme.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            AppUtils.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext)
                    .load(thumb).error(R.drawable.place_holder)
                    .placeholder(R.drawable.place_holder).into(holder.itemImg);
        }
        holder.itemFavorite.setSelected(true);
        holder.layoutFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                holder.itemFavorite.setSelected(false);
                int adapterPosition = holder.getAdapterPosition();
                notifyItemRemoved(adapterPosition);
                if (mCallBack != null) {
                    mCallBack.OnRemoveLike(KeyboardTheme);
                }
            }
        });
        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, ThemeDetailActivity.class);
                intentApply.putExtra(ThemeDetailActivity.SOURCE_KEY, KeyboardTheme);
                intentApply.putExtra(ThemeDetailActivity.DISPLAY_URL_KEY, KeyboardTheme.getImgPath());
                intentApply.putExtra(ThemeDetailActivity.ZIP_URL_KEY, KeyboardTheme.getZipPath());
                intentApply.putExtra(ThemeDetailActivity.NAME_KEY, KeyboardTheme.getTitleName());
                intentApply.putExtra(ThemeDetailActivity.GIF_KEY, KeyboardTheme.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(ThemeDetailActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);


            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private FrameLayout layoutFavorite;
        private ImageView itemImg, itemFavorite;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            layoutFavorite = itemView.findViewById(R.id.layout_favorite);
            itemImg = itemView.findViewById(R.id.im);
            itemFavorite = itemView.findViewById(R.id.im_favorite);

        }

    }

}
